***********************************************************************
      SUBROUTINE init_gluonfusion()
*----------------------------------------------------------------------
c  author   : Michael Kubocz
c  modified : 09.10.08
***********************************************************************

      IMPLICIT NONE

      real*8 alpha

#include "../../utilities/koppln.inc"
#include "ggf_process.inc"
#include "ggf_default.inc"

      CALL loadfile("ggflo.dat",.false.)

c  PROCESS choice
      CALL read_int("PROCESSGGF",processGGF,3)
c  subprocess choice
      CALL read_Logical("SUBPRQQ",subprQQ,.true.)
      CALL read_Logical("SUBPRQG",subprQG,.true.)
      CALL read_Logical("SUBPRGG",subprGG,.true.)
c  MSSM parameter
      CALL read_real("TAN_BETA",tan_BETA,1d0)
      CALL read_real("ALPHA",alpha,0d0)

      CALL closefile
*----------------------------------------------------------------------
*----------------------------------------------------------------------
*----------------------------------------------------------------------
*----------------------------------------------------------------------
*----------------------------------------------------------------------
      sin_Beta  = Sin(atan(tan_Beta))
      cos_Beta  = Cos(atan(tan_Beta))
      sin_Alpha = Sin(alpha)
      cos_Alpha = Cos(alpha)

***********************************************************************

 1    write(6,*)'--------- PROCESS PARAMETERS IN GLUON FUSION ---------'
      write(6,*)''
      write(6,*)' -->               ATTENTION             <--'
      write(6,*)' -->  threshold effects at m_H = 2*m_top <--'
      write(6,*)' -->  please use m_H = 2*m_top +- 1 GeV  <--'
      write(6,*)' -->               ATTENTION             <--'
      write(6,*)''
      if(PROCESSGGF.eq.0)then
         write(6,*)"  PROCESSGGF ","     : ",PROCESSGGF
         write(6,*)"--------- TOY MODEL ---------"
      else
         write(6,*)"  PROCESSGGF ","     : ",PROCESSGGF
      endif
      write(6,*)''
      write(*,"(T4,A,T20,A,F9.4)")"m_Higgs","= ",xmh
      write(*,"(T4,A,T20,A,F9.4)")"m_top","= ",m_top
      write(*,"(T4,A,T20,A,F9.4)")"m_bottom","= ",m_bottom
      write(*,"(T4,A,T20,A,F9.4)")"m_bottomMSb","= ",m_bottomMSb
      if(processGGF.eq.0) then
         write(*,"(T4,A,T20,A,F9.4)")"tan_Beta","= ",tan_Beta
         write(*,"(T4,A,T20,A,F9.4)")"sin_Beta","= ",sin_Beta
         write(*,"(T4,A,T20,A,F9.4)")"cos_Beta","= ",cos_Beta
         write(*,"(T4,A,T20,A,F9.4)")"Alpha (h,H)","= ",Alpha
         write(*,"(T4,A,T20,A,F9.4)")"sin_Alpha","= ",sin_Alpha
         write(*,"(T4,A,T20,A,F9.4)")"cos_Alpha","= ",cos_Alpha
      endif
      if(processGGF.gt.5) then
         write(*,"(T4,A,T20,A,F9.4)")"tan_Beta","= ",tan_Beta
         write(*,"(T4,A,T20,A,F9.4)")"sin_Beta","= ",sin_Beta
         write(*,"(T4,A,T20,A,F9.4)")"cos_Beta","= ",cos_Beta
         write(*,"(T4,A,T20,A,F9.4)")"Alpha (h,H)","= ",Alpha
         write(*,"(T4,A,T20,A,F9.4)")"sin_Alpha","= ",sin_Alpha
         write(*,"(T4,A,T20,A,F9.4)")"cos_Alpha","= ",cos_Alpha
      endif
      print*,''
      write(6,*) '------------------- PROCESS(ES) ---------------------'
      if (subprQQ) write(6,*) 'QUARK - QUARK SCATTERING '
      if (subprQG) write(6,*) 'QUARK - GLUON SCATTERING ' 
      if (subprGG) write(6,*) 'GLUON - GLUON SCATTERING '
***********************************************************************
      SELECT CASE(processGGF)
      CASE(0)  ! example: cp-even/odd mixing gimmicks
         cp_even_mod  = 1d0      !  strength of cp-even coupling
         cp_odd_mod   = 2d0/3d0  !  strength of cp-odd coupling
         write(6,*)''
         write(*,"(T4,A,T20,A,F9.4)")"cp_even_mod","= ",cp_even_mod
         write(*,"(T4,A,T20,A,F9.4)")"cp_odd_mod","= ",cp_odd_mod
         write(6,*)""
         write(6,*) "cp-even SM Higgs H (coupling via top-loop) "
         write(6,*) "cp-even SM Higgs H (coupling via running bottom-loop) "
         write(6,*) "cp-odd MSSM Higgs A (coupling via top-loop)"
         write(6,*) "cp-odd MSSM Higgs A (coupling via running bottom-loop) "
         HloopTop      = .true.
         cplModHtop    = cp_even_mod*(m_top**2)/tan_Beta
         HloopBottom   = .true.
         cplModHbottom = cp_even_mod*(m_bottomMSb**2)*tan_Beta
         AloopTop      = .true.
         cplModAtop    = cp_odd_mod*(m_top**2)/tan_Beta
         AloopBottom   = .true.
         cplModAbottom = cp_odd_mod*(m_bottomMSb**2)*tan_Beta
*----------------------------------------------------------------------
      CASE(1)
         print*,''
         write(6,*) 'cp-even SM Higgs H in the mtop -> infinity limit'
         Heff          = .true.
         cplModHeff    = 1d0/3d0 
*----------------------------------------------------------------------
      CASE(2) 
         print*,'                                                         '
         write(6,*) 'cp-odd MSSM(2HDM) Higgs A in the mtop->infinity limit'
         Aeff          = .true.
         cplModAeff    = 0.5d0  
*---------------------------------------------------------------------- 
      CASE(3) 
         print*,''
         write(6,*) 'cp-even SM Higgs H (coupling via top-loop) '
         HloopTop      = .true.
         cplModHtop    = m_top**2
*----------------------------------------------------------------------
      CASE(4) 
         print*,''
         write(6,*) 'cp-even SM Higgs H (coupling via bottom-loop) '
         HloopBottom   = .true.
         cplModHbottom = m_bottomMSb**2
*----------------------------------------------------------------------
      CASE(5) 
         print*,''
         write(6,*) 'cp-even SM Higgs H (coupling via top-loop) '
         write(6,*) 'cp-even SM Higgs H (coupling via bottom-loop) '
         HloopTop      = .true.
         HloopBottom   = .true.
         cplModHtop    = m_top**2
         cplModHbottom = m_bottomMSb**2
*----------------------------------------------------------------------
      CASE(6) 
         print*,' '
         write(6,*) 'cp-odd MSSM Higgs A (coupling via top-loop) '
         AloopTop      = .true.
         cplModAtop    = (m_top**2)/tan_Beta
*----------------------------------------------------------------------
      CASE(7)
         print*,''
         write(6,*) 'cp-odd MSSM Higgs A (coupling via bottom-loop) '
         AloopBottom   = .true.
         cplModAbottom = (m_bottomMSb**2)*tan_Beta
*----------------------------------------------------------------------
      CASE(8)
         print*,''
         write(6,*) 'cp-odd MSSM Higgs A (coupling via top-loop) '
         write(6,*) 'cp-odd MSSM Higgs A (coupling via bottom-loop) '
         AloopTop      = .true.
         AloopBottom   = .true.
         cplModAtop    = (m_top**2)/tan_Beta
         cplModAbottom = (m_bottomMSb**2)*tan_Beta
*----------------------------------------------------------------------
      CASE(9)
         print*,''
         write(6,*) 'cp-even MSSM Higgs h (coupling via top-loop) '
         sHloopTop     = .true.
         cplModsHtop   =  -(m_top**2)*cos_alpha/sin_Beta
*----------------------------------------------------------------------
      CASE(10)
         print*,''
         write(6,*) 'cp-even MSSM Higgs h (coupling via bottom-loop) '
         sHloopBottom  = .true.
         cplModsHbottom= (m_bottomMSb**2)*sin_alpha/cos_Beta
*----------------------------------------------------------------------
      CASE(11)
         print*,''
         write(6,*) 'cp-even MSSM Higgs h (coupling via top-loop) '
         write(6,*) 'cp-even MSSM Higgs h (coupling via bottom-loop) '
         sHloopTop     = .true.
         sHloopBottom  = .true.
         cplModsHtop   = -(m_top**2)*cos_alpha/sin_Beta
         cplModsHbottom= (m_bottom**2)*sin_alpha/cos_Beta 
*----------------------------------------------------------------------
      CASE(12)
         print*,''
         write(6,*) 'cp-even MSSM Higgs H (coupling via top-loop) '
         bHloopTop     = .true.
         cplModbHtop   = -(m_top**2)*sin_alpha/sin_Beta 
*----------------------------------------------------------------------
      CASE(13)
         print*,''
         write(6,*) 'cp-even MSSM Higgs H (coupling via bottom-loop) '
         bHloopBottom  = .true.
         cplModbHbottom= -(m_bottomMSb**2)*cos_alpha/cos_Beta 
*----------------------------------------------------------------------
      CASE(14)
         print*,''
         write(6,*) 'cp-even MSSM Higgs H (coupling via top-loop) '
         write(6,*) 'cp-even MSSM Higgs H (coupling via bottom-loop) '
         bHloopTop     = .true.
         bHloopBottom  = .true.
         cplModbHtop   = -(m_top**2)*sin_alpha/sin_Beta
         cplModbHbottom= -(m_bottomMSb**2)*cos_alpha/cos_Beta 
*----------------------------------------------------------------------

      END SELECT

      write(6,*) '-----------------------------------------------------'
     
 2    END

