
c
      real*8 function m2s_QCDww(
     &                   xi,	!in:  Feynman x parameters of incoming fermions
     &                   p,	!in:  momenta associated with external fermions
     &                   v	!in:  momenta associated with Z/H dec. fermions
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/coupl.inc"
      integer bos, nlo
      real*8 xi(nx), p(0:3,max_p), v(0:3,max_v), m2s

c  helicity selection
      integer jsig, jsig1, jsig3, jsig5
      common /chelsum/ jsig,jsig1,jsig3,jsig5

      complex*16 zero, z1
      parameter (zero=(0d0,0d0))
c
c declare external functions
c
      integer FL_ZH
      real*8 dotp
      double complex dotrc
      external FL_ZH, dotrc, dotp
c
c alfas, scales etc
#include "VBFNLO/utilities/scales.inc"
      real*8 qww(0:3)
      double precision  alphas, xmt, alfa, xmz, xmw,s2w, xmh
      common /bkopin/   alphas, xmt, alfa, xmz, xmw, s2w, xmh
c
c declare local variables
c
      real*8 q_sf, qq, polcol

      integer init/0/, I, J, mu, nu, id, crossing
      save init
c
c declare variables for summation process
c
      INTEGER ires

      integer FSIGN(4+max_v), physToDiag(4), nmin, nmax, nproc(4)
      save nmax, nproc
c
c store contributions from subprocess ip in res(ip) where
      real*8 pbar(0:3,4+max_v), qqres(6), qgres(6) ,ggres(6), res
      real*8 dddd, uuuu, ddss, uuss, ssuu, uucc, 
     1       dduu, uudd, ducs, csdu, ddgg, ggdd, uugg, gguu
c
c declare parton distribution variables
c
      real*8 pdf(-6:6,2)
      real*8 U1,D1,S1,C1,B1,G1, UB1,DB1,SB1,CB1,BB1,
     1       U2,D2,S2,C2,B2,G2, UB2,DB2,SB2,CB2,BB2

      real*8 auxpt,auxy,auxphi,fac
c
c define program switches
c
      logical ldebug
      parameter (ldebug=.false.)		!output debug information
      logical lqqqq, lqqgg, lqgqg, lggqq
      parameter (lqqqq=.true., lqqgg=.true., lqgqg=.true., lggqq=.true.)

      if ( init .eq. 0 ) then

         write(6,*) " "
         write(6,*) "W+W- jj amplitude square information:"
         write(6,*) "-----------------------------------------------"
         write(6,*) " "
*            call vtoww_reset
        
         if (nfl.eq.4) then
            print*," For NC processes external b-quark contributions",
     1             " are excluded"
         elseif (nfl.eq.5) then
            print*," For NC processes external b-quark contributions",
     1             " are included"
         else
            print*," Check setting of nfl in global.inc "
         endif
         init = 1
      endif

      do i = 1,6
         qqres(i) = 0.0d0
         qgres(i) = 0.0d0
         ggres(i) = 0.0d0
      enddo
      res = 0.0d0

      if ( ldebug ) then
 10      format( " p(", i1, ") = ", 4(f10.3, 2x) )
 20      format( " v(", i1, ") = ", 4(f10.3, 2x) )
c
         write(6,*) " "
         do i = 1, n_v
            write(6,20) i, v(0,i), v(1,i), v(2,i), v(3,i)
         end do
         print*," parton momenta "
         do i = 1, n_p
            write(6,10) i, p(0,i), p(1,i), p(2,i), p(3,i)
         end do
c
         write(6,*) " "
         write(6,*) "xi(1), xi(2) =", xi
         write(6,*) "mu_f =",sqrt(mufsq(1,1)),sqrt(mufsq(2,1))
      end if


c     
c call PDF subroutine in order to determine parton
c distributions in the incoming (anti)protons.
c
      q_sf = sqrt(mufsq(1,1))
     
      call pdfproton( xi(1), q_sf, pdf(-6,1) )        ! f_a(x1)

      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) )        ! f_a(x2)

      DO i = -6,6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)
      ENDDO
      
      g1  = pdf(0,1)
      db1 = pdf(-1*sign1,1)
      d1  = pdf( 1*sign1,1)
      ub1 = pdf(-2*sign1,1)
      u1  = pdf( 2*sign1,1)
      s1  = pdf( 3*sign1,1)
      sb1 = pdf(-3*sign1,1)
      c1  = pdf( 4*sign1,1)
      cb1 = pdf(-4*sign1,1)
      b1  = pdf( 5*sign1,1)
      bb1 = pdf(-5*sign1,1)

      g2  = pdf(0,2)
      db2 = pdf(-1*sign2,2)
      d2  = pdf( 1*sign2,2)
      ub2 = pdf(-2*sign2,2)
      u2  = pdf( 2*sign2,2)
      s2  = pdf( 3*sign2,2)
      sb2 = pdf(-3*sign2,2)
      c2  = pdf( 4*sign2,2)
      cb2 = pdf(-4*sign2,2)
      b2  = pdf( 5*sign2,2)
      bb2 = pdf(-5*sign2,2)
c select helicity
      jsig = 0
      
      do mu = 0,3             ! kinematics for H-->WW -->4 lepton decay
         pbar(mu,5) = v(mu,2)   ! l+
         pbar(mu,6) = v(mu,1)   ! nu
         pbar(mu,7) = v(mu,3)   ! nubar
         pbar(mu,8) = v(mu,4)   ! l-
      enddo
      fsign(5) = -1
      fsign(6) = 1
      fsign(7) = -1
      fsign(8) = 1


! PBAR1 = incoming quark
! PBAR2 = outgoing quark
! QBAR1 = incoming gluon
! QBAR2 = outgoing gluon
!1	LBAR(I,1,1) 	! LBAR of V1 -> LBAR L, OUTGOING ANTI-LEPTON	! nubar
!2      LBAR(I,2,1) 	! L    of V1 -> LBAR L, OUTGOING LEPTON	        ! e
!3	LBAR(I,1,2) 	! LBAR of V2 -> LBAR L, OUTGOING ANTI-LEPTON    ! ebar
!4	LBAR(I,2,2) 	! L    of V2 -> LBAR L, LEPTON                  ! nu


c*****  1.  ********
c*******************  q1 q3 ---> q2 q4 W W   **********************
c*******************  q1 g3 ---> q2 g4 W W   **********************
         
c   physToDiag(ext.momentum label) = Feynman diagram label

      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4
C NOTE: for call of wbf_zh it is important that p(*,1,*) and p(*,3,*)
c correspond to 1-2 fermion line ALWAYS, i.e physToDiag(1/2)={1,3} and 
c similarly physToDiag(3/4)={2,4} for the 3-4 fermion line

      fsign(1) = 1
      fsign(2) = 1
      fsign(3) = 1
      fsign(4) = 1

      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo
      crossing = 1
      if (lqqqq.or.lqgqg) then
         call qqwwqq_MG(pbar,fsign, crossing, dddd, uuuu, ddss, uuss, 
     1               ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2               ggdd, uugg, gguu)
         

      endif
      
      

c qq -> qq
      if (lqqqq) then
      qqres(1) = (d1*d2 + s1*s2)*dddd/2d0
     1         + (u1*u2 + c1*c2)*uuuu/2d0
     2         + (d1*s2 + s1*d2)*ddss
     3         + (u1*s2 + c1*d2)*uuss
     4         + (s1*u2 + d1*c2)*ssuu
     5         + (u1*c2 + c1*u2)*uucc
     6         + (d1*u2 + s1*c2)*dduu
     7         + (u1*d2 + c1*s2)*uudd
     8         + (d1*c2 + s1*u2)*ducs
     9         + (c1*d2 + u1*s2)*csdu

*      qqres(1) = (d1*s2 + s1*d2)*ddss

      endif
c qg -> qg, gq -> gq
      if (lqgqg) then
      qgres(1) = (d1 + s1)*g2*ddgg
     1         + g1*(d2 + s2)*ggdd
     2         + (u1 + c1)*g2*uugg
     3         + g1*(u2 + c2)*gguu
      endif
     

c*****  2.  ********     
c*******************  q1 qb4 ---> q2 qb3 W W   **********************

      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=4
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=3

      fsign(3) = -1
      fsign(4) = -1

      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo
      
      crossing = 2
      if (lqqqq) then
c         print *,"-------START 2: q1 qb4 ---> q2 qb3 W W"
         call qqwwqq_MG(pbar,fsign, crossing, dddd, uuuu, ddss, uuss, 
     1               ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2               ggdd, uugg, gguu)
      
c qqbar -> qqbar
      qqres(2) = (d1*db2 + s1*sb2)*dddd
     1         + (u1*ub2 + c1*cb2)*uuuu
     2         + (d1*sb2 + s1*db2)*ddss
     3         + (u1*sb2 + c1*db2)*uuss
     4         + (sb1*u2 + db1*c2)*ssuu
     5         + (u1*cb2 + c1*ub2)*uucc
     6         + (d1*ub2 + s1*cb2)*dduu
     7         + (ub1*d2 + cb1*s2)*uudd
     8         + (d1*sb2 + s1*db2)*ducs
     9         + (db1*s2 + sb1*d2)*csdu      
      endif
     
c*****  3.  ********   
C*******************  q1 qbar2 ---> qbar3 q4 W W   **********************
C*******************  q1 qbar2 ---> g3 g4 W W   **********************

      physToDiag(1)=1    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=2
      physToDiag(3)=3    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4

      fsign(1) = 1
      fsign(2) = -1
      fsign(3) = -1
      fsign(4) = 1
      
      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo
      crossing = 3
c      print *,"-------START ---------"
      if (lqqqq.or.lqqgg) then
      call qqwwqq_MG(pbar,fsign, crossing, dddd, uuuu, ddss, uuss, 
     1               ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2               ggdd, uugg, gguu)

      endif
c      print *,"-------STOP ---------"
    !  goto 99
c qqbar -> qqbar
      if (lqqqq) then
      qqres(3) = (d1*db2 + s1*sb2)*ddss
     3         + (u1*ub2 + c1*cb2)*uuss
     4         + (ub1*u2 + cb1*c2)*ssuu
     5         + (u1*ub2 + c1*cb2)*uucc
     6         + (d1*db2 + s1*sb2)*dduu
     7         + (db1*d2 + sb1*s2)*uudd
     8         + (d1*ub2 + s1*cb2)*ducs
     9         + (ub1*d2 + cb1*s2)*csdu           
      endif
      if (lqqgg) then
      qqres(3)=qqres(3) + (d1*db2 + s1*sb2)*ddgg/2d0 ! q qbar -> g g
     2         + (db1*d2 + sb1*s2)*ggdd/2d0
     &         + (u1*ub2 + c1*cb2)*uugg/2d0
     &         + (ub1*u2 + cb1*c2)*gguu/2d0
      endif

c*****  4.  ******** 
C*******************  qbar2 q3 ---> qbar1 q4 W W  ******************
C*******************  qbar2 g3 ---> qbar1 g4 W W  ******************      

      physToDiag(1)=2    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=1    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=4

      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = 1 
      fsign(4) = 1
         
      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo
      crossing = 4
      if (lqqqq.or.lqgqg) then
      call qqwwqq_MG(pbar,fsign, crossing, dddd, uuuu, ddss, uuss, 
     1               ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2               ggdd, uugg, gguu)
      endif
c qbarq -> qbarq
      if (lqqqq) then
      qqres(4) = (db1*d2 + sb1*s2)*dddd
     1         + (ub1*u2 + cb1*c2)*uuuu
     2         + (db1*s2 + sb1*d2)*ddss
     3         + (ub1*s2 + cb1*d2)*uuss
     4         + (s1*ub2 + d1*cb2)*ssuu
     5         + (ub1*c2 + cb1*u2)*uucc
     6         + (db1*u2 + sb1*c2)*dduu
     7         + (u1*db2 + c1*sb2)*uudd
     8         + (ub1*c2 + cb1*u2)*ducs
     9         + (u1*cb2 + c1*ub2)*csdu
      endif
c qbarg -> qbar g
      if (lqgqg) then
      qgres(2) = (db1 + sb1)*g2*ddgg + g1*(db2 + sb2)*ggdd
     &         + (ub1 + cb1)*g2*uugg + g1*(ub2 + cb2)*gguu

      endif
     

   

c*****  5.  ******** 
C*******************  qbar4 q3 ---> q2 qbar1 W W  ******************
C*******************  g4    g3 ---> q2 qbar1 W W  ******************      

      physToDiag(1)=4    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=3
      physToDiag(3)=2    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=1

      fsign(1) = -1
      fsign(2) = 1
      fsign(3) = 1 
      fsign(4) = -1
         
      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo
      crossing = 5
      if (lqqqq.or.lggqq) then
      call qqwwqq_MG(pbar,fsign, crossing, dddd, uuuu, ddss, uuss, 
     1               ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2               ggdd, uugg, gguu)

      endif
c qbarq -> qbarq
      if(lqqqq) then
      qqres(5) = (db1*d2 + sb1*s2)*ddss
     3         + (db1*d2 + sb1*s2)*uuss
     4         + (d1*db2 + s1*sb2)*ssuu
     5         + (ub1*u2 + cb1*c2)*uucc
     6         + (ub1*u2 + cb1*c2)*dduu
     7         + (u1*ub2 + c1*cb2)*uudd
     8         + (sb1*c2 + db1*u2)*ducs
     9         + (u1*db2 + c1*sb2)*csdu
      endif
c qbarg -> qbar g
      if (lggqq) ggres(1) = g1*g2*(ddgg*2d0 + uugg*2d0)
     
c*****  6.  ******** 
C*******************  qbar2 qbar4 ---> qbar1 qbar3 W W  ******************

      physToDiag(1)=2    !physToDiag(1/2) are labels of incoming quarks
      physToDiag(2)=4
      physToDiag(3)=1    !physToDiag(3/4) are labels of outgoing quarks.
      physToDiag(4)=3

      fsign(1) = -1
      fsign(2) = -1
      fsign(3) = -1 
      fsign(4) = -1
         
      do mu = 0,3
         do i = 1,4
            pbar(mu,physToDiag(i))=p(mu,i)
         enddo
      enddo
      crossing = 6
      if (lqqqq) then
      call qqwwqq_MG(pbar,fsign, crossing, dddd, uuuu, ddss, uuss, 
     1               ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2               ggdd, uugg, gguu)    

 

c qbarqbar -> qbarqbar
      qqres(6) = (db1*db2 + sb1*sb2)*dddd/2d0
     1         + (ub1*ub2 + cb1*cb2)*uuuu/2d0
     2         + (db1*sb2 + sb1*db2)*ddss
     3         + (ub1*sb2 + cb1*db2)*uuss
     4         + (sb1*ub2 + db1*cb2)*ssuu
     5         + (ub1*cb2 + cb1*ub2)*uucc
     6         + (db1*ub2 + sb1*cb2)*dduu
     7         + (ub1*db2 + cb1*sb2)*uudd
     8         + (ub1*sb2 + cb1*db2)*ducs
     9         + (sb1*ub2 + db1*cb2)*csdu
      endif
   

c*****************  end of process evaluation  *********************
 99   continue
      m2s=0.0
      m2s = (qqRES(1)+qqRes(2)+qqRES(3)+qqRes(4)+qqRES(5)+qqRes(6))*(1.0/4d0)*(1.0/9d0)
*      m2s = (qqRES(1))*(1.0/9d0)
      m2s = m2s + (qgRES(1)+qgres(2))*(1.0/4d0)*(1.0/24d0)
      m2s = m2s + ggRES(1)*(1.0/4d0)*(1.0/64d0)
    
*     scale for running alphas
      m2s = m2s*als(1,1)*als(2,1)/(alphas**2)

      m2s_QCDww =m2s
      

      RETURN
      END




      subroutine qqwwqq_MG(pbar,sign, crossing, dddd, uuuu, ddss, uuss, 
     1                     ssuu, uucc, dduu, uudd, ducs, csdu, ddgg, 
     2                     ggdd, uugg, gguu)
      implicit none                !        for H -> xx (based on bbar)
#include "VBFNLO/utilities/global.inc"
c
c variables for the main part of the program
c
      double precision  pbar(0:3,4+max_v),  pbs(0:3,4+max_v), ans
      double precision  dddd, uuuu, ddss, uuss, ssuu, uucc, 
     1                  dduu, uudd, ducs, csdu, ddgg, ggdd, uugg, gguu
      double precision  p(0:3,4+max_v), p21(0:4), p43(0:4), p65(0:4),
     1                  p87(0:4), ph(0:4)
      integer  sign(4+max_v), fs(4+max_v), crossing, mu,i
      double complex zz
c assign momenta for switched quark lines
      do mu = 0,3
         pbs(mu,1) = pbar(mu,3)
         pbs(mu,2) = pbar(mu,4)
         pbs(mu,3) = pbar(mu,1)
         pbs(mu,4) = pbar(mu,2)
         do i = 5,8
            pbs(mu,i) = pbar(mu,i)
         enddo
      enddo
      fs(1) = sign(3)
      fs(2) = sign(4)
      fs(3) = sign(1)
      fs(4) = sign(2)
      do i = 5,8
         fs(i) = sign(i)
      enddo
c crossing parameter :
c     crossing = 1  : q1 q3  -> q2 q4 
c     crossing = 2  : q1 qb4 -> q2 qb3
c     crossing = 3  : q1 qb2 -> qb3 q4

      if ((crossing.ne.3).and.(crossing.ne.5)) then
c 1. dd -> dd
         call sDD2DDww(pbar,sign,dddd)

c 2. uu -> uu
         call sUU2UUww(pbar,sign,uuuu)
      else
         dddd = 0d0
         uuuu = 0d0
      endif
         
c 3. ds -> ds 
      call sDS2DSww(pbar,sign,ddss)

c 4. uc -> uc
      call sUC2UCww(pbar,sign,uucc)

c 5. us -> us  &  su -> su 
      call sUS2USww(pbar,sign,uuss)
      call sUS2USww(pbs ,fs  ,ssuu)

c 6. du -> du  &  ud -> ud
      call sDU2DUww(pbar,sign,dduu)
      call sDU2DUww(pbs ,fs  ,uudd)

c 7. dc -> us  &  cd -> su
      call sDC2USww(pbar,sign,ducs)
      call sDC2USww(pbs ,fs  ,csdu)

      if ((crossing.ne.2).and.(crossing.ne.6)) then
*      if (crossing.ne.2) then
c 8. dg -> dg  &  gd -> gd
         call sDG2DGww(pbar,sign,ddgg)
         call sDG2DGww(pbs ,fs  ,ggdd)

c 9. ug -> ug  &  gu -> gu
         call sUG2UGww(pbar,sign,uugg)
         call sUG2UGww(pbs ,fs  ,gguu)
      else
         ddgg = 0d0
         ggdd = 0d0
         uugg = 0d0
         gguu = 0d0
      endif
      end
