c this routine is used to call routines which compute pentagons 
c	(depending on NLO "true pentagons" or "boxlike" contributions 
c		are computed)
c	
c	this is a generalization of "J_virtual_tri_box_pent45" to
c	quarkline with arbitrary helicity isig
c
c
c	last modified by Barbara Jager on Sept. 21, 2005
c
c 
c--------------------------------------------------------------------------- 
      subroutine  VVV_J_virtual_tri_box_pent_isig45(psi,p,nq1,nq2, sign, musq,
c     input currents (any ORDERED couple among [J1,J2,J3]) in DHELAS format
c     They can be  jmu1,jmu2  or  jmu1,jmu3   or   jmu2,jmu3
     #     jal,jbe,
c     factor of proportionality of qal/qbe in jal = jal"+xal*qal vv.	
     #	   xal,xbe,    
c     uncontracted external current. It can be 1, 2 or 3
     #     num_ret_current,
c     specify piece to be returned: 
c          NLO = +5#include leading q^mu/m_V terms of 
c	                        pentagons which can be related to boxes,
c				set other pentagon contributions zero
c          NLO = -5      finite Pentagon contributions only (no box-type terms)
     #	   NLO,		 		     
c     returned current
     #     Jret)
c     the corresponding Born current
c     #     Jborn)

      implicit none
      double complex  psi(2,-1:1,2)
      double precision p(0:3,8)
      double precision musq
      double complex  jal(0:5),jbe(0:5),xal,xbe
      integer num_ret_current,nlo,nq1,nq2
      double complex jret(0:3,-1:1)
      integer mu,kb, sign(8),isig
      double precision qa(0:4),qb(0:4),fa(0:4,4),fb(0:4,4),
     # 		       fab(0:4,4),fba(0:4,4)
      double complex psia(2,-1:1,4),psib(2,-1:1,4),
     #		     psiab(2,-1:1,4),psiba(2,-1:1,4)		      
      double complex  jborn(0:5,-1:1),jret_nlo(0:3,-1:1)	      
   
      double precision  qak(0:4,2),qbk(0:4,2)	      
      double complex cak(0:5,2),cbk(0:5,2),jak(0:5,2),jbk(0:5,2),
     #		     j0ak(0:5,-1:1,2),j0bk(0:5,-1:1,2),
     #		     j0aa(0:5,-1:1,2),j0bb(0:5,-1:1,2),
     #		     jvirt1(0:5,-1:1),jvirt2(0:5,-1:1),
     #		     jvirt3(0:5,-1:1),jvirt4(0:5,-1:1),
     #		     jvabd(0:5,-1:1,3)
  
      double complex psiak(2,-1:1,2,4),psibk(2,-1:1,2,4),
     #  	     psipak(2,-1:1,2,4),psipbk(2,-1:1,2,4)
      double precision  fqak(0:4,2,4),fqbk(0:4,2,4),
     # 			fpak(0:4,2,4),fpbk(0:4,2,4)

c variables for virtual corections
c
#include "VBFNLO/utilities/global.inc"
      double precision pi2o3,c2,c2o4pi,cvirtc
      parameter (pi2o3=pi**2/3.0d0, cvirtc=pi2o3-7.0d0)
      parameter (c2=4d0/3d0, c2o4pi=c2/4d0/pi)
 	 	
      ! compute (outgoing) momenta asociated with external currents:
      
      qa(0) = dreal(jal(4))
      qa(1) = dreal(jal(5))
      qa(2) = dimag(jal(5))
      qa(3) = dimag(jal(4))
      qb(0) = dreal(jbe(4))
      qb(1) = dreal(jbe(5))
      qb(2) = dimag(jbe(5))
      qb(3) = dimag(jbe(4))
      
      qa(4) = qa(0)**2-qa(1)**2-qa(2)**2-qa(3)**2
      qb(4) = qb(0)**2-qb(1)**2-qb(2)**2-qb(3)**2
 
      if (nlo.eq.-5) then       ! need "genuine" pentagon contributions
 
  ! compute Born current for pentagon line:
        	
         if (num_ret_current.eq.1) then ! mu,jal,jbe
	
     	    do isig = -1,1,2 ! hel.of quark line
               call bra2c(psi(1,isig,nq2),.true.,p(0,nq2),isig,qb,
     #                   jbe,psib(1,isig,nq2),fb(0,nq2))
               call bra2c(psib(1,isig,nq2),.false.,fb(0,nq2),isig,qa,
     #                   jal,psiba(1,isig,nq2),fba(0,nq2))
            enddo !isig	 
   
            call curr6(1,psiba(1,-1,nq2),fba(0,nq2),psi(1,-1,nq1),p(0,nq1),
     #           jborn(0,-1))	
     
         elseif (num_ret_current.eq.2) then ! jal,mu,jbe
	
      	    do isig = -1,1,2 ! hel.of quark line
               call bra2c(psi(1,isig,nq2),.true.,p(0,nq2),isig,qb,
     #            jbe,psib(1,isig,nq2),fb(0,nq2))
               call ket2c(psi(1,isig,nq1),.true.,p(0,nq1),isig,qa,
     #            jal,psia(1,isig,nq1),fa(0,nq1))
            enddo !isig	 
           
	    call curr6(1,psib(1,-1,nq2),fb(0,nq2),psia(1,-1,nq1),fa(0,nq1),
     #           jborn(0,-1))	
 
         elseif (num_ret_current.eq.3) then ! jal,jbe,mu
	
      	    do isig = -1,1,2 ! hel.of quark line
               call ket2c(psi(1,isig,nq1),.true.,p(0,nq1),isig,qa,
     #            jal,psia(1,isig,nq1),fa(0,nq1))
               call ket2c(psia(1,isig,nq1),.false.,fa(0,nq1),isig,qb,
     #            jbe,psiba(1,isig,nq1),fba(0,nq1))
            enddo !isig	 
           
	    call curr6(1,psi(1,-1,nq2),p(0,nq2),psiba(1,-1,nq1),fba(0,nq1),
     #           jborn(0,-1))	
 
         else 
      	
            print*,"this configuration for pentagon line is not allowed" 
      
         endif
	 



      !  compute pentagon line including born contribution:
         
	 do isig = -1,1,2
	    
         call J_virtual_tri_box_pent_VVV_isig(psi,p,nq1,nq2,isig,sign, musq,
     1        jal, jbe, num_ret_current, jret_nlo(0,isig) )

	! subtract born from nlo current:

            do mu = 0,3
               jret(mu,isig) = jret_nlo(mu,isig) - cvirtc*jborn(mu,isig) 
            enddo

c additional terms ~jborn to go back to M_V(-s) 
c that means (-s)^-eps is prefactor                      

            do mu = 0,3
               jret(mu,isig) = jret(mu,isig)                                 
     1             + (3*pi*(0d0,1d0)-pi**2)*jborn(mu,isig)
            enddo

	 enddo !isig

      endif                     ! nlo = -5

      return
      end
