****************************************************************************
*     This file contains routines for the unweighting of events.
****************************************************************************

****************************************************************************
      Subroutine ResetWeights
****************************************************************************
*     call this subroutine at the beginning of each iteration
****************************************************************************
      implicit none
      integer nevraw,nevovr,prenevacc
      logical lwri
      common/events/nevraw,nevovr,prenevacc,lwri

#include "lha.inc"

      maxweight=0d0
      nevraw=0
      nevovr=0
      nevacc=0
      nevall=0
      prenevacc=0
      lwri=.false.

      return
      end

****************************************************************************
      Subroutine ReweightingInfo
****************************************************************************
      implicit none
      integer nevraw,nevovr,prenevacc
      logical lwri
      common/events/nevraw,nevovr,prenevacc,lwri

#include "lha.inc"

      print*,"number of events after cuts =",nevraw
      print*,"number of events to calculate pre-maximal weight =",prenevunw
      print*,"pre-maximal weight",maxweight
      if(lha)then
         if(unweighting)then
            print*,"maximal weight",wtmax*maxweight
         else
            print*,"maximal weight",wtmax
         endif
         print*,"number of unweighted events =",nevacc
      endif
      print*,""
      
      return
      end


****************************************************************************
      Subroutine Reweight(evnweight)
****************************************************************************

      implicit none
      real*8 evnweight,RandomNumber,rn
      external RandomNumber
      integer nevraw,nevovr,prenevacc
      logical lwri
      common/events/nevraw,nevovr,prenevacc,lwri

#include "lha.inc"

      nevraw=nevraw+1

      if(.not.lwri) then
         if(eventweight.gt.maxweight) then 
            maxweight=eventweight
         endif
         if(nevraw.eq.prenevunw) then                              
            lwri=.true.
         endif
      endif
      if(unweighting)then
         if(lwri)then
            if(eventweight.gt.maxweight)then
               nevovr=nevovr+1
               evnweight = eventweight/maxweight
            else
               rn=RandomNumber()
               if(rn*maxweight.lt.eventweight) then ! event is to be kept
                  prenevacc=prenevacc+1
                  evnweight=1d0
               else
                  evnweight=0d0
               endif
            endif
         endif
      endif
      return
      end


