c
c     Manuel Baehr:     mb@particle.uni-karlsruhe.de
c     Initial version:  2005 March 17
c     Last modified:    2005 April 04
c
      real*8 function m2s_stpw(
c     &                   nlo,   !in:  Born only for nlo=0, +interference for 1
     &                   xi,     !in:  Feynman x parameters of incoming fermions
     &                    p,     !in:  momenta associated with external partons
     &                    v     !in:  momenta associated with decay leptons
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"

      integer i, mu, fsign(max_p+max_v), count , maxcount
      double precision xi(nx), q_sf, pdf(-6:6,2)
      double precision p(0:3,max_p),v(0:3,max_v), pbar(0:3,max_p+max_v), test(0:3)
      double precision r(0:3), tmp(1,4), tmp2(1,4)
      double precision mass2, processes, boostacc, ampacc, boosum, ampsum(4), boo
      double precision maxboostacc,maxampacc
      Parameter (maxboostacc=5.0d-9, maxampacc=1.0d-5)
      Parameter (maxcount=50000)
      DATA count /0/
      DATA boosum /0d0/
      DATA boo /4.6D0/
      DATA ampsum(1), ampsum(2), ampsum(3), ampsum(4) /0D0,0D0,0D0,0D0/
      external mass2


      real*8 alphas, xmt
      common /bkopin/ alphas, xmt
c
c alfas, scales etc
#include "VBFNLO/utilities/scales.inc"


      do mu= 0, 3
         do i = 1, n_p
            pbar(mu,i) = p(mu,i)
         enddo
         do i = 1, n_v
            pbar(mu,n_p+i) = v(mu,i)
         enddo
      enddo

      q_sf = sqrt(mufsq(1,1))
      call pdfproton( xi(1), q_sf, pdf(-6,1) ) ! f_a(x1)
      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) ) ! f_a(x2)
      q_sf = xmt/4d0 * xif
      
      do i=-6, 6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)

c         print*, "pdf(",i," ,1):", pdf(i,1)
c         print*, "pdf(",i," ,2):", pdf(i,2)
      enddo


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                  pdflib standards                                    c 
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      

c     pdfproton returESns x*f(x)
c     pdf(1,) = d
c     pdf(2,) = u
c     pdf(3,) = s
c     pdf(4,) = c
c     pdf(5,) = b
c     pdf(6,) = t = 0
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                   single top production                              c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c FOR PROCESS : q b -> q b e- ve~ e+ ve
      do i = 1, n_p+n_v
         fsign(i) = 1
      enddo
      fsign(6) = - 1
      fsign(7) = - 1

      call SFULLTEST(pbar, fsign, tmp)
 
ccccc lorentz invariance test cccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc          
      if (count .le. maxcount) then
      do i = 0, 4
         test(i) = pbar(i,5)+pbar(i,6)
      enddo         
      boostacc = mass2(test)

      do i = 1, 8
         call boostl(boo, pbar(0,i))        ! 4.6 entspricht gamma=50
      enddo

      do i = 0, 4
         test(i) = pbar(i,5)+pbar(i,6)
      enddo         
c      print*, "------------ new event"
      boostacc = mass2(test)/boostacc - 1
      
      if (boostacc .gt. maxboostacc)	then
        print*,"--- WARNING --- boostacc=",boostacc," at count",count
      endif

      call SFULLTEST(pbar,fsign, tmp2)    
c      do i = 1, 4
c         ampacc = ( tmp(1,i) / tmp2(1,i) - 1 )
c         print*, ampacc
c         call hf1(7+i, real( -log10(ampacc) ), 1. )
c      enddo

c mittelwerte:
c
      count = count + 1
c
      do i = 1, 4
         ampacc = abs( tmp(1,i) / tmp2(1,i) - 1 )
         ampsum(i) = ampsum(i) + ampacc
	 
	 if (ampacc .gt. maxampacc)	then
	   print*,"--- WARNING --- ampacc=(",i,")=",ampacc," at count",count
	 endif
	 
      enddo
c
      boosum = boosum + boostacc

      if (count.eq.maxcount) then
	  print*,"  ",maxcount," Boostacc SUM ", boosum/count
	  do i = 1, 4
           print*,"  ",maxcount," AMP acc SUM",i, ampsum(i)/count
          enddo
      endif      
      
c      print*,"booacc ", boosum/count
c
c      do i = 1, 4
c         print*,"AMPacc ",i, ampsum(i)/count
c      enddo
      endif
      

cccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc

      call switchmom( pbar(0,1), pbar(0,2) )

      call SFULLTEST(pbar, fsign, tmp2)

      m2s_stpw = 0d0

      m2s_stpw = m2s_stpw + processes(pdf,tmp,tmp2,fsign(1),0)
      m2s_stpw = m2s_stpw + processes(pdf,tmp,tmp2,fsign(1),1)  
c     letzter index sagt 0=top,1=antitopamplitudes dazunehmen

c restore the incoming momenta
      call switchmom( pbar(0,1), pbar(0,2) )   
cccccccccccccccccccccccccccccccccccccccccccccc

c CROSSING FOR PROCESS : q~ b -> q~ b e- ve~ e+ ve

c      print*, "-----------crossing------------"

      fsign(1) = - 1
      fsign(3) = - 1
      call switchmom( pbar(0,1), pbar(0,3) )
      call SFULLTEST(pbar, fsign, tmp)

      call switchmom( pbar(0,1), pbar(0,3) )
      call switchmom( pbar(0,1), pbar(0,2) )
      call switchmom( pbar(0,1), pbar(0,3) )

      call SFULLTEST(pbar, fsign, tmp2)

      m2s_stpw = m2s_stpw + processes(pdf,tmp,tmp2,fsign(1),0)
      m2s_stpw = m2s_stpw + processes(pdf,tmp,tmp2,fsign(1),1)
      
c      print*, "-----------end------------"
      return
      end



      double precision function processes (pdf,tmp, tmp2, fsign,anti)
      
      implicit none

      integer anti, fsign
      double precision pdf(-6:6,2), tmp(1,4), tmp2(1,4)

c      print*, "anti =", anti
c      print*, tmp(1,1+2*anti), 1+2*anti
c      print*, tmp(1,2+2*anti), 2+2*anti

      processes = 0d0               

      processes = processes + tmp(1,1+2*anti) * pdf( fsign*2, 1) * pdf(5,2) ! ub->ut
      processes = processes + tmp(1,1+2*anti) * pdf( fsign*4, 1) * pdf(5,2) ! cb->ct

      processes = processes + tmp(1,2+2*anti) * pdf( fsign*1, 1) * pdf(5,2) ! db->dt
      processes = processes + tmp(1,2+2*anti) * pdf( fsign*3, 1) * pdf(5,2) ! sb->st     


      processes = processes + tmp2(1,1+2*anti) * pdf( fsign*2, 2) * pdf(5,1) ! bu->tu
      processes = processes + tmp2(1,1+2*anti) * pdf( fsign*4, 2) * pdf(5,1) ! bc->tc

      processes = processes + tmp2(1,2+2*anti) * pdf( fsign*1, 2) * pdf(5,1) ! bd->dt
      processes = processes + tmp2(1,2+2*anti) * pdf( fsign*3, 2) * pdf(5,1) ! bs->st

      return
      end function
