c
c     Manuel Baehr:     mb@particle.uni-karlsruhe.de
c     Initial version:  2005 March 17
c     Last modified:    2005 April 04
c
      real*8 function m2s_singletop(
c     &                   bos,   !in:  Boson identifier, 2 = Z, 6=H, 34=W+W-
c     &                   nlo,   !in:  Born only for nlo=0, +interference for 1
     &                   xi,     !in:  Feynman x parameters of incoming fermions
     &                    p,     !in:  momenta associated with external partons
     &                    v      !in:  momenta associated with decay leptons
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"
#include "VBFNLO/utilities/scales.inc"

      integer i, mu, fsign(6)
      double precision xi(nx), q_sf, pdf(-6:6,2)
      double precision p(0:3,max_p),v(0:3,max_v),
     &                 pbar(0:3,max_p+max_v), tmp, tmp2, test(4)
      double precision mass2
      external mass2


      real*8 alphas, xmt, alpha, xmz, xmw
      common /bkopin/ alphas, xmt, alpha, xmz, xmw
c
c alfas, scales etc
c#include "scales.inc"


      do mu= 0, 3
         do i = 1, n_p
            pbar(mu,i) = p(mu,i)
         enddo
         do i = 1, n_v
            pbar(mu,n_p+i) = v(mu,i)
         enddo
      enddo

c if calc_qsq has been called in main-prog      q_sf = sqrt(mufsq(1,1))
      q_sf = sqrt(mufsq(1,1))
      call pdfproton( xi(1), q_sf, pdf(-6,1) ) ! f_a(x1)
      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) ) ! f_a(x2)

      do i=-6, 6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)

c         print*, "pdf(",i," ,1):", pdf(i,1)
c         print*, "pdf(",i," ,2):", pdf(i,2)
      enddo


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                  pdflib standards                                    c 
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      

c     pdfproton returns x*f(x)
c     pdf(1,) = d
c     pdf(2,) = u
c     pdf(3,) = s
c     pdf(4,) = c
c     pdf(5,) = b
c     pdf(6,) = t = 0
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                   single top production  (t-channel)                 c 
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c FOR PROCESS : u b -> d b e+ ve

c      do i = 1, 6
c         fsign(i) = 1
c      enddo
c      fsign(5) = -1

c      call SUBDBENU(pbar, fsign, tmp)
      

ccccc lorentz invariance test ccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c      print*, pbar(0,2)
c      do i = 1, 6
c         call boostl(1d0, pbar(0,i))
c      enddo
c      print*, pbar(0,2)
c      print*, "----------"
c      call SUBDBENU(pbar,fsign, tmp2)
c      if ( abs( tmp / tmp2 - 1) .gt. 1d-10 ) then
c         print*, tmp / tmp2 - 1
c      endif
cccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc

c      print*, "/////////////"
c      print*, tmp, pdf(1,1)
c      print*, "/////////////"
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c      test(1) = 0d0
c      test(1) = test(1) + tmp * pdf(2,1) * pdf(5,2) ! ub->td
c      test(1) = test(1) + tmp * pdf(4,1) * pdf(5,2) ! cb->ts

c      call switchmom( pbar(0,1), pbar(0,2) )
c      call SUBDBENU(pbar, fsign, tmp)
c      call switchmom( pbar(0,1), pbar(0,2) )

c      test(1) = test(1) + tmp * pdf(2,2) * pdf(5,1) ! bu->td
c      test(1) = test(1) + tmp * pdf(4,2) * pdf(5,1) ! bc->ts

c crossing --------------------------

c      fsign(1) = -1
c      fsign(3) = -1
c      call switchmom( pbar(0,1), pbar(0,3) )

c      call SUBDBENU(pbar, fsign, tmp)


c      test(2) = 0d0
c      test(2) = test(2) + tmp * pdf(-1,1) * pdf(5,2) ! d~b ->tu~
c      test(2) = test(2) + tmp * pdf(-3,1) * pdf(5,2) ! s~b ->tc~

c      call switchmom( pbar(0,1), pbar(0,3) )
c      call switchmom( pbar(0,1), pbar(0,2) )
c      call switchmom( pbar(0,1), pbar(0,3) )
c      call SUBDBENU(pbar, fsign, tmp)

c      test(2) = test(2) + tmp * pdf(-1,2) * pdf(5,1) ! bd~ ->tu~
c      test(2) = test(2) + tmp * pdf(-3,2) * pdf(5,1) ! bs~ ->tc~    

c      m2s_singletop = test(1)+test(2)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                   single anti-top production (t-channel)             c 
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      

      do i = 1, 6
         fsign(i) = -1
      enddo
      fsign(5) = 1

      call SUBDBENU_ANTI(pbar, fsign, tmp)

      test(3) = 0d0
      test(3) = test(3) + tmp * pdf(-2,1) * pdf(-5,2) ! u~b~->t~d~
      test(3) = test(3) + tmp * pdf(-4,1) * pdf(-5,2) ! c~b~->t~s~

      call switchmom( pbar(0,1), pbar(0,2) )
      call SUBDBENU_ANTI(pbar, fsign, tmp)
      call switchmom( pbar(0,1), pbar(0,2) )

      test(3) = test(3) + tmp * pdf(-2,2) * pdf(-5,1) ! b~u~->t~d~
      test(3) = test(3) + tmp * pdf(-4,2) * pdf(-5,1) ! b~c~->t~s~

c crossing -------------------------

      fsign(1) = 1
      fsign(3) = 1
      call switchmom( pbar(0,1), pbar(0,3) )

      call SUBDBENU_ANTI(pbar, fsign, tmp)

      test(4) = 0d0
      test(4) = test(4) + tmp * pdf(1,1) * pdf(-5,2) ! db~ ->t~u
      test(4) = test(4) + tmp * pdf(3,1) * pdf(-5,2) ! sb~ ->t~c


      call switchmom( pbar(0,1), pbar(0,3) )
      call switchmom( pbar(0,1), pbar(0,2) )
      call switchmom( pbar(0,1), pbar(0,3) )
      call SUBDBENU_ANTI(pbar, fsign, tmp)
      call switchmom( pbar(0,1), pbar(0,2) )

      test(4) = test(4) + tmp * pdf(1,2) * pdf(-5,1) ! b~d ->t~u
      test(4) = test(4) + tmp * pdf(3,2) * pdf(-5,1) ! b~s ->t~c    

      m2s_singletop = test(3)+test(4)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      

      return
      end

